; DevSter Noise Machine Z80 Driver Srouce Code
; Copyright 2004, Joseph Norman
; Visit: http://devster.retrodev.com

	.org 	$0000
init:
	di

	ld	ix,fmdata+16

loop:
	ld	a,$FF
	cp	(ix)
	jr	nz,loop2
	ld	ix,(fmdata)
loop2:
	ld	iy,$4000
	ld	a,(ix)
	and	$04
	jr	z,loop3
	ld	iy,$4002
loop3:

	ld	c,(ix+1)	; Load Octave+Frequency
	srl	c
	srl	c
	srl	c
	ld	b,0
	ld	hl,notes
	add	hl,bc
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,(ix+1)
	and	$07
	sla	a
	sla	a
	sla	a
	add	a,b
	ld	b,a

wait_fm:
	bit	7,(iy)
	jr	nz,wait_fm
	ld	a,(ix)		; Send Octave+Higher Frequency
	and	$03
	add	a,$A4
	ld	(iy),a
	ld	(iy+1),b

wait_fm2:
	bit	7,(iy)
	jr	nz,wait_fm2
	sub	4		; Send Lower Frequency
	ld	(iy),a
	ld	(iy+1),c

	ld	hl,$4000
wait_fm4:
	bit	7,(hl)
	jr	nz,wait_fm4
	ld	a,$28		; Send KEY ON
	ld	(hl),a
	ld	a,(ix)
	and	$0F
	add	a,$F0
	inc	hl
	ld	(hl),a

	ld	a,(ix)		; DELAY
	srl	a
	srl	a
	srl	a
	and	$0E
	jr	z,skip
	sub	2
	ld	b,0
	ld	c,a
	ld	hl,fmdata+2
	add	hl,bc
	ld	b,(hl)
	inc	hl
	ld	c,(hl)
	ld	hl,$7F05
wait1:				; DELAY 1
	bit	3,(hl)
	jr	nz,wait1
wait2:
	bit	3,(hl)
	jr	z,wait2
	dec	b
	jr	nz,wait1

	ld	de,$4000
wait_fm3:
	bit	7,(iy)
	jr	nz,wait_fm3
	ld	a,$28		; KEY OFF
	ld	(de),a
	ld	a,(ix)
	and	$0F
	inc	de
	ld	(de),a

wait5:				; DELAY 1
	bit	3,(hl)
	jr	nz,wait5
wait6:
	bit	3,(hl)
	jr	z,wait6
	dec	c
	jr	nz,wait5
skip:
	inc	ix
	inc	ix
	jp	loop

notes:
	.dw	617	; = $269
	.dw	653	; = $28D
	.dw	692	; = $2B4
	.dw	733	; = $2DD
	.dw	777	; = $309
	.dw	823	; = $337
	.dw	872	; = $368
	.dw	924	; = $39C
	.dw	979	; = $3D3
	.dw	1037	; = $40D
	.dw	1099	; = $44B
	.dw	1164	; = $48C

fmdata:	.db	"StAr"

;	.db	4	; 7	SIXTEENTH
;	.db	3
;	.db	11	; 14	EIGHTH
;	.db	3
;	.db	16	; 21	DOTTED EIGHT
;	.db	5
;	.db	23	; 28	QUARTER
;	.db	5
;	.db	35	; 42	DOTTED QUARTER
;	.db	7
;	.db	49	; 56	HALF
;	.db	7
;	.db	103	; 112	WHOLE
;	.db	9

	.END

